VERSION 5.00
Begin VB.Form frmMain 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "Delete Post Office"
   ClientHeight    =   1095
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   3990
   Icon            =   "frmMain.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   1095
   ScaleWidth      =   3990
   StartUpPosition =   2  'CenterScreen
   Begin VB.CommandButton cmdQuit 
      Caption         =   "Quit"
      Height          =   375
      Left            =   2400
      TabIndex        =   3
      Top             =   600
      Width           =   1455
   End
   Begin VB.CommandButton cmdDelete 
      Caption         =   "Delete"
      Height          =   375
      Left            =   120
      TabIndex        =   2
      Top             =   600
      Width           =   1455
   End
   Begin VB.TextBox txtPostoffice 
      Height          =   285
      Left            =   1800
      TabIndex        =   1
      Top             =   120
      Width           =   2055
   End
   Begin VB.Label Label1 
      Caption         =   "Post office to delete:"
      Height          =   375
      Left            =   120
      TabIndex        =   0
      Top             =   120
      Width           =   1455
   End
End
Attribute VB_Name = "frmMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit


Public Function DeletePostoffice(sPostoffice As String)

    'deletes a postoffice and all the directories + content
    
    On Error GoTo errHandler
    
    Dim oPostoffice As Object
    Dim oFSO As Object      'New FileSystemObject
    Dim lResult As Long
    
    Set oPostoffice = CreateObject("MEAOPO.Postoffice")
    Set oFSO = CreateObject("Scripting.FileSystemObject")
    
    'first we delete all the entries in the files
    'this is a pain
    
    'first the postoffice file
    oPostoffice.Account = sPostoffice
    oPostoffice.Name = sPostoffice
    oPostoffice.Status = -1
    
    lResult = oPostoffice.RemovePostoffice()
    
    'remove address maps
    DeleteMapping "", sPostoffice
    
    'remove auth
    RemoveAuth sPostoffice, ""
    
    'remove domains
    RemoveDomain sPostoffice, ""
    
    'then we delete all the files
    'delete the postoffice directory in the config directory
    If oFSO.FolderExists(GetMailConfigDirectory() & "\postoffices\" & sPostoffice) Then
        oFSO.DeleteFolder GetMailConfigDirectory() & "\postoffices\" & sPostoffice, True
    End If
    
    'then the mail directories
    'MsgBox "checking for :" & GetMailRoot() & "\" & sPostOffice
    If oFSO.FolderExists(GetMailRoot() & "\" & sPostoffice) Then
        'MsgBox "about to delete:" & GetMailRoot() & "\postoffices\" & sPostOffice
        oFSO.DeleteFolder GetMailRoot() & "\" & sPostoffice, True
    End If
    
    Exit Function
    
errHandler:
    MsgBox "DeletePostoffice:Error:" & Err.Description
End Function

Public Function DeleteMapping(sDestination As String, sPostoffice As String)

    'remove an address map
    Dim oAddressMap As Object
    Dim lResult As Long
    
    Set oAddressMap = CreateObject("MEAOAM.AddressMap")

    'first we get the old one
    With oAddressMap
        .Account = sPostoffice
        .DestinationAddress = sDestination
        .Scope = ""
        .SourceAddress = ""
        lResult = .RemoveAddressMap()
    End With
       
    'cos lresult will be 0 if it doesn't delete anything, which may happen if no destination specified
    If lResult = 0 And Len(sDestination) > 0 Then
       ' MsgBox "Failed to remove map."
        Exit Function
    End If
            
    Exit Function
    
errHandler:
    MsgBox "Error:DeleteMapping: " & Err.Description
End Function


Public Function RemoveAuth(sPostoffice As String, sUser As String)

    'returns the password for a user
    'this is located in the POPAccounts.tab file
    
    Dim oAUTHLogin As Object
    Dim lResult As Long
    
    Set oAUTHLogin = CreateObject("MEAOAU.Login")
    
    With oAUTHLogin
        .Account = sPostoffice
        .Password = ""
        .Status = -1
        .UserName = sUser
        .Description = ""
        lResult = .RemoveLogin()
    End With
    
    
    Exit Function
    
errHandler:
    'file problem usually..
    MsgBox "Could not delete auth entry."
End Function


Public Function RemoveDomain(sPostoffice As String, sDomain As String)

    On Error GoTo errHandler
    
    Dim oSMTPDomain As Object
    Dim lResult As Long
    
    Set oSMTPDomain = CreateObject("MEAOSM.Domain")

    With oSMTPDomain
        .AccountName = sPostoffice
        .DomainName = sDomain
        .DomainRedirectionHosts = ""
        .DomainRedirectionStatus = -1
        .Status = -1
        lResult = .RemoveDomain()
    End With
    
    Exit Function
    
errHandler:
    MsgBox "RemoveDomain:Error:" & Err.Description
End Function

Public Function GetMailRoot()
    GetMailRoot = GetRegistryString("SOFTWARE\mail enable\mail enable\connectors\sf", "Mail Root Directory")
End Function


Public Function GetMailConfigDirectory() As String
    On Error Resume Next
    GetMailConfigDirectory = GetRegistryString("SOFTWARE\Mail Enable\Mail Enable", "Configuration Directory")
End Function

Private Sub cmdDelete_Click()

    DeletePostoffice txtPostoffice.Text
    
End Sub

Private Sub cmdQuit_Click()
Unload Me

End Sub
